'''Updates TV program guide using XMLTV'''
__licence__ = "GPLv2"
__copyright__ = "2007, Lauri Taimila"
__author__ = "Lauri Taimila <lauri@taimila.com>"

from backend.core.message_type_priority import MessageType
from backend.core.message_handler import MessageHandler

from utils.logger import Logger

class GuideUpdater(MessageHandler):
    """Guide updater updates TV-guide."""

    # Message bus
    __message_bus = None

    def __init__(self, message_bus):
        """Create a new guide updater object."""
        MessageHandler.__init__(self)
        self.__message_bus = message_bus
        self.logger = Logger().getLogger(
                                  'backend.components.tvguide.GuideUpdater')

    def updateGuide(self):
        """Lauch updater thread."""
        # a Thread should download XML, update cache db and emit Message
        pass

    # Implementes MessageHandler interface
    def handleMessage(self, message):
        '''Handles messages passed to it'''
        if message.get_type() == MessageType.UPDATE_GUIDE:
            self.updateGuide()

    def getName(self):
        '''Returns the name of the MessageHandler'''
        return "Guide Updater"
