'''WeatherFetcher - Update all weather feeds to local cache.'''

__licence__ = "GPLv2"
__copyright__ = "2007, Lauri Taimila"
__author__ = "Lauri Taimila <lauri@taimila.com>"

import os
import threading

# Configuration
from utils.configuration import Configuration

from utils.logger import Logger

class WeatherFetcher(threading.Thread):
    """Update weather information to the local weather cache database."""

    # Feed database file
    WEATHER_DB = os.path.expanduser(
        Configuration().get_cfg_path() + 'cache/weather.db')

    def __init__(self, message_bus, location):
        """
        Create a new weather fetch thread.
        @param message_bus: MessageBus object
        @param location: Location information (String)
        """
        threading.Thread.__init__(self)
        self.setName("WeatherFetcher")
        self.message_bus = message_bus
        self.logger = Logger().getLogger(
                                   'backend.components.weather.WeatherFetcher')
        self.location = location

    def run(self):
        """
        Update weather cache in a seperated thread.
        """
        # Open weather database
        #db_conn = sqlite.connect(self.WEATHER_DB)
        #db_cursor = db_conn.cursor()

        #TODO: connect to net, download weather info, update downloaded info
        # into cache
        # Is SQLite cache overkill here? Maybe we should use file instead?
        # Let's discuss :)

        # Notify that weather database has been updated
        #db_conn.close()
        #self.logger.info("Weather cache has been updated")
        #self.message_bus.notifyMessage(
        #    Message(MessageType.WEATHER_INFO_UPDATED))
