#!/usr/bin/env python
'''System tray icon for Entertainer backend'''

import sys
import os
import gobject
import ConfigParser
from ConfigParser import ParsingError

try:
    import pygtk
    pygtk.require("2.4")
except:
    pass
try:
    import gtk
except:
    sys.exit(1)

from backend.core.message import Message
from backend.core.message_type_priority import MessageType, MessagePriority
from backend.core.message_bus_proxy import MessageBusProxy
from utils.system_tray_icon import SystemTrayIcon

message_dict = { MessageType.RECORDING_STARTED : MessagePriority.VERY_LOW,
                 MessageType.RECORDING_STOPPED : MessagePriority.VERY_LOW}

gobject.threads_init()
gtk.gdk.threads_init()

# Create tray icon
gtk.gdk.threads_enter()

#Start SystemTrayIcon with show on start True
tray_icon = SystemTrayIcon(start_frontend=True)
gtk.gdk.threads_leave()

try:
    # Open connection to backend
    proxy = MessageBusProxy(message_dict, tray_icon.get_message_handler(),
        "system-tray-icon")
    proxy.connectToMessageBus()
    proxy.start()
    tray_icon.get_message_handler().set_message_bus_proxy(proxy)

except:
    print "Backend is not running. Start backend and try again."
    sys.exit(1)

gtk.gdk.threads_enter()
gtk.main()
gtk.gdk.threads_leave()
