'Tests Configuration'

__license__ = "GPLv2"
__copyright__ = "2008, Matt Layman"
__author__ = "Matt Layman <laymansterms.dev@gmail.com>"

import unittest
import sys
import os
import shutil

from random import random
from math import floor

sys.path += [os.path.abspath('..')]

from utils.configuration import Configuration

class ConfigurationTest(unittest.TestCase):
    '''Test for utils.configuration'''

    def setUp(self):
        '''Set up the test

        Creates a temporary filename for each thread
        '''

        rand_id = floor(random() * 1000)
        self.cfg_dir = os.path.join(os.path.abspath('.'), '%s' % rand_id)

        try:
            shutil.rmtree(self.cfg_dir)
        except OSError:
            pass

        self.config = Configuration(self.cfg_dir)

    def tearDown(self):
        '''Clean up after the test'''
        if os.path.exists(self.cfg_dir):
            shutil.rmtree(self.cfg_dir)

    def testCreateDir(self):
        '''Test Configuration object directory creation'''
        test_name = os.path.expanduser('~/.config/testCreate/')
        self.new_config = Configuration(test_name)

        self.assertTrue(os.path.exists(test_name))

        shutil.rmtree(test_name)


