'''Logger object tests'''

__license__ = 'GPLv2'
__copyright__ = '2008, Matt Layman'
__author__ = 'Matt Layman <laymansterms.dev@gmail.com>'

import unittest
import sys
import os
import logging

sys.path += [os.path.abspath('..')]

from utils.logger import Logger

class TestLogger(unittest.TestCase):
    '''Logger test case'''

    def setUp(self):
        '''See unittest.TestCase'''
        # Found out the hard way that the logging module is a threadsafe
        # singleton so only one needs to (and can be) created
        self.log_file = os.path.join(
            os.path.abspath('.'), 'data/entertainer.log')

        self.logger = Logger(self.log_file)

    def tearDown(self):
        '''See unittest.TestCase'''
        try:
            os.remove(self.log_file)
        except OSError:
            pass

    def testGetLogger(self):
        '''Tests logger.getLogger without a name'''
        self.lowlogger = self.logger.getLogger()

        self.assertTrue(isinstance(self.lowlogger, logging.Logger))

    def testNamedLogger(self):
        '''Tests logger.getLogger with a name'''
        self.lowlogger = self.logger.getLogger('test')
        self.lowlogger.debug('Logger test for named logger test')
        # test this log for its name

    def testNoParams(self):
        '''Tests multiple logging mechanism'''
        # No way to test now because logging will only permit the creation of
        # one log file per module. Commented out until I can determine a way
        # to test this.
        #self.default_path = os.path.join(
        #    os.path.abspath('.'), 'data/entertainerdefault.log')
        #try:
        #    os.remove(self.default_path)
        #except OSError:
        #    pass

        #self.logger = Logger()
        #self.lowlogger = self.logger.getLogger()

        #self.assertTrue(os.path.exists(self.default_path))

